
dofile("Base.rte/Constants.lua")
dofile("Orks.rte/Scripts/AI/NativeOrkAI.lua")

function Create(self)


	self.garbTimer = Timer(); 
	self.WTime = Timer();

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.activeCamo = false;
	self.CloakTimer = Timer();

	self.AI = NativeOrkAI:Create(self)

end

function Update(self)

local health = self.Health;
  if health > 0 then



--IF THE UNIT IS NOT DEAD...
if not(self:IsDead()) then



--IF ACTIVE CAMO IS ON, DO THESE THINGS
if self.activeCamo == true then

if self.WTime:IsPastSimMS(75) then
--DETECTOR CHECK
 for actor in MovableMan.Actors do
    if actor.Team ~= self.Team then
	local parvector = SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx);
	local pardist = parvector.Magnitude;
	local percep = ToActor(actor).Perceptiveness

	local shieldradius = 175
      if pardist < shieldradius * percep then
		self.CloakTimer:Reset();
		self.change = true;
      end
    end
 end
--END DETECTOR CHECK
end


--SEE IF UNIT IS FIRING
 if self:GetController():IsState(Controller.WEAPON_FIRE) or self:GetController():IsState(Controller.WEAPON_RELOAD) then
		self.CloakTimer:Reset();
		self.change = true;
 end


end


--SYSTEM OF CHECKS TO INFORM INVISIBLITY SYSTEM WHETHER OR NOT IT SHOULD ACTIVATE
if not self.CloakTimer:IsPastSimMS(135) and self.Scale == 0 then
	self.change = true;
	self.HUDVisible = true;
end
if self.CloakTimer:IsPastSimMS(975) and not self.CloakTimer:IsPastSimMS(1175) then
	self.change = true;
end
if self.CloakTimer:IsPastSimMS(1175) and self.activeCamo == false then
	self.change = true;
	self.HUDVisible = false;
end


--INVISIBILITY SYSTEM: HANDLE ACTUAL INVISIBILITY CHANGE
if self.change == true then
for i = 0, MovableMan:GetMOIDCount() do
	if MovableMan:GetRootMOID(i) == self.ID then
		local object = MovableMan:GetMOFromID(i);
		if not(object:IsDevice()) or (object:IsDevice() and ((object.PresetName == "Stealth Shoota") or (object.PresetName == "Choppa"))) then
			if self.activeCamo == true then
				object.Scale = 1;
			else
				object.Scale = 0;


			end
		end
	end
end

if self.activeCamo == true then
	self.activeCamo = false;
else
	self.activeCamo = true;
end

self.change = false;
end

	else

--...IF THE UNIT IS DEAD, PERFORM END LIFE FUNCTIONS
for i = 0, MovableMan:GetMOIDCount() do
	if MovableMan:GetRootMOID(i) == self.ID then
		local object = MovableMan:GetMOFromID(i);
		if not(object:IsDevice()) or (object:IsDevice() and ((object.PresetName == "Stealth Shoota") or (object.PresetName == "Choppa"))) then
				object.Scale = 1;
				self.HUDVisible = true;
		end
	end
end
self.RotAngle = self.RotAngle * 0.98;

end



	local con = self:GetController();
	con:SetState(9,false);


if con:IsState(3) or con:IsState(4) or con:IsState(10) or con:IsState(5) then


if self.WTime:IsPastSimMS(80) then
	self.WTime:Reset();

   local rotangle = self.RotAngle;
   if rotangle > -0.15 and rotangle < 0.15 then

	local alt = 18;
	if self.FGLeg ~= nil and self.BGLeg ~= nil then
		if con:IsState(3) or con:IsState(4) then
			alt = 23;
		else
			alt = 21;
		end
		
		local dx = 12
		if SceneMan.SceneWidth > self.Pos.X+12 and 0 < self.Pos.X-12 then
			dx = 12;
			if self.Vel.X < 0 then
				dx = -12;
			end
			if math.abs(self.Vel.X) < 1 then
				dx = 0;
			end
		else
			dx = 0;
		end	

		if not con:IsState(10) and not con:IsState(5) then

			local ray = SceneMan:CastObstacleRay(self.Pos, Vector(0,alt*1.5), Vector(), Vector(), self.ID, self.Team,128, 0);
			if ray > 0 then
				if math.abs(self.Vel.Y) < 5 then
					ray = SceneMan:CastObstacleRay(Vector(self.Pos.X+dx, self.Pos.Y) , Vector(0,alt*1.5) , Vector() , Vector(), self.ID ,self.Team, 128 , 0);
					if ray <=0 then
						ray = ((2*alt)/3);
					end
					if math.abs(alt-ray) < 15 then
						self.Vel.Y = self.Vel.Y-(0.25*(alt-ray));
					end
				end
				if con:IsState(3) and self.Vel.X < 5 then
					self.Vel.X = self.Vel.X+1.15;
				elseif con:IsState(4) and self.Vel.X > -5 then
					self.Vel.X = self.Vel.X-1.15;
				end
		   end
		end

		self.Vel.Y = 0.9925*self.Vel.Y;
		self.AngularVel = 0.95*self.AngularVel;

	end	
   end		
end

end



	self:ClearForces()
	self.AngularVel = self.AngularVel * 0.97;

	if self.garbTimer:IsPastSimMS(3000 - (100 - health)*10) then
		collectgarbage("collect");
		self.garbTimer:Reset();
		if health < 100 then
			self.Health = health + 1;
		end
	end  
  end
end


function UpdateAI(self)
	self.AI:Update(self)
end

function Destroy(self)
	if MovableMan:IsActor(self) == true then
		self.AngularVel = 0;
	end
end